#version 150

#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform float GameTime;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec4 vertexColorE;
in vec2 texCoord0;
in vec2 texCoord1;
in vec4 normal;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator;
    vec4 colorE = texture(Sampler0, texCoord0) * vertexColorE * ColorModulator;
    if (color.a < 0.1) {discard;}

    float Animation = GameTime * 1000;
    float opacity = ceil(color.a * 255);

    if (opacity == 254) {color = colorE;}
    if (opacity == 253) {color = mix(colorE*1.2 , (color + colorE*1.2)/2 , pow(sin(Animation),2));}

    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
